#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
using System.Collections;  // add this declaration so you can use ArrayList()
using System.IO;	//Added for StreamWriter
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{

    [Description("Enter the description of your new custom indicator here")]
    public class HG5_CP_Opens : Indicator
    {
        #region Variables
			private double open_2 = 0;	private double open_16 = 0;	private double open_60 = 0;	private double open_288 = 0;			
			private double open_3 = 0;	private double open_18 = 0;	private double open_72 = 0;	private double open_360 = 0;
			private double open_4 = 0;	private double open_20 = 0;	private double open_80 = 0;	private double open_480 = 0;
			private double open_5 = 0;	private double open_24 = 0;	private double open_90 = 0;	private double open_720 = 0;
			private double open_6 = 0;	private double open_30 = 0;	private double open_96 = 0;	private double open_1440 = 0;
			private double open_8 = 0;	private double open_32 = 0;	private double open_120 = 0;		
			private double open_9 = 0;	private double open_36 = 0;	private double open_144 = 0;		
			private double open_10 = 0;	private double open_40 = 0;	private double open_160 = 0;	
			private double open_12 = 0;	private double open_45 = 0;	private double open_180 = 0;		
			private double open_15 = 0;	private double open_48 = 0;	private double open_240 = 0;
		
			private string path 			= "C:\\Users\\Forrest\\Desktop\\cpStudy.txt";		//Added for StreamWriter
			private System.IO.StreamWriter sw;													//Added for StreamWriter
			private bool printHeader = true;
        #endregion

        protected override void Initialize()
        {
			#region BarsAdded
			Add(PeriodType.Minute, 2);	
			Add(PeriodType.Minute, 3);
			Add(PeriodType.Minute, 4);
			Add(PeriodType.Minute, 5);
			Add(PeriodType.Minute, 6);
			Add(PeriodType.Minute, 8);
			Add(PeriodType.Minute, 9);
			Add(PeriodType.Minute, 10);
			Add(PeriodType.Minute, 12);
			Add(PeriodType.Minute, 15);
			Add(PeriodType.Minute, 16);	
			Add(PeriodType.Minute, 18);
			Add(PeriodType.Minute, 20);	
			Add(PeriodType.Minute, 24);
			Add(PeriodType.Minute, 30);
			Add(PeriodType.Minute, 32);	
			Add(PeriodType.Minute, 36);	
			Add(PeriodType.Minute, 40);
			Add(PeriodType.Minute, 45);
			Add(PeriodType.Minute, 48);
			Add(PeriodType.Minute, 60);			
			Add(PeriodType.Minute, 72);			
			Add(PeriodType.Minute, 80);			
			Add(PeriodType.Minute, 90);			
			Add(PeriodType.Minute, 96);			
			Add(PeriodType.Minute, 120);	
			Add(PeriodType.Minute, 144);		
			Add(PeriodType.Minute, 160);		
			Add(PeriodType.Minute, 180);		
			Add(PeriodType.Minute, 240);
			Add(PeriodType.Minute, 288);
			Add(PeriodType.Minute, 360);
			Add(PeriodType.Minute, 480);
			Add(PeriodType.Minute, 720);
			Add(PeriodType.Minute, 1440);
			#endregion
			
			#region PlotsAdded
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0002) TF_2"));		//1
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0003) TF_3"));		//2
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0004) TF_4"));		//3
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0005) TF_5"));		//4
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0006) TF_6"));		//5
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0008) TF_8"));		//6
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0009) TF_9"));		//7
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0010) TF_10"));		//8
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0012) TF_12"));		//9
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0015) TF_15"));		//10
			
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0016) TF_16"));		//1
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0018) TF_18"));		//2
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0020) TF_20"));		//3
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0024) TF_24"));		//4
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0030) TF_30"));		//5
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0032) TF_32"));		//6
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0036) TF_36"));		//7
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0040) TF_40"));		//8
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0045) TF_45"));		//9
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0048) TF_48"));		//10
			
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0060) TF_60"));		//1
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0072) TF_72"));		//2
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0080) TF_80"));		//3
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0090) TF_90"));		//4
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0096) TF_96"));		//5
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0120) TF_120"));		//6
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0144) TF_144"));		//7
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0160) TF_160"));		//8
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0180) TF_180"));		//9
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0240) TF_240"));		//10
			
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0288) TF_288"));		//6
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0360) TF_360"));		//7
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0480) TF_480"));		//8
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "0720) TF_720"));		//9
			Add(new Plot(Color.FromKnownColor(KnownColor.Transparent), PlotStyle.Line, "1440) TF_1440"));		//10			
			#endregion

            Overlay				= true;
        }


        protected override void OnBarUpdate()
        {
//			if(CurrentBar==1 && BarsInProgress==0)	{
//				ClearOutputWindow();
//				Print("Date" + ", "+ "Time"+", " + "dTime"+", " + "O"+", " + "H"+", " + "L"+", " + "C"
//					+"," + "m2"+"," + "m3"+"," + "m4"+"," + "m5"+"," + "m6"+", " + "m8"+"," + "m9"+", " + "m10"+"," + "m12"+"," + "m15"
//					+"," + "m16"+"," + "m18"+"," + "m20"+"," + "m24"+"," + "m30"+", " + "m32"+"," + "m36"+", " + "m40"+"," + "m45"+"," + "m48"
//					+"," + "m60"+"," + "m72"+"," + "m80"+"," + "m90"+"," + "m96"+", " + "m120"+"," + "m144"+", " + "m160"+"," + "m180"+"," + "m240"
//					+"," + "m288"+"," + "m360"+"," + "m480"+"," + "m720"+"," + "m1440");
//				return;
//			}
			
    		if (CurrentBars[0] <= BarsRequired || CurrentBars[1] <= BarsRequired || CurrentBars[2] <= BarsRequired || CurrentBars[3] <= BarsRequired 
				|| CurrentBars[4] <= BarsRequired || CurrentBars[5] <= BarsRequired || CurrentBars[6] <= BarsRequired || CurrentBars[7] <= BarsRequired
				|| CurrentBars[8] <= BarsRequired || CurrentBars[9] <= BarsRequired || CurrentBars[10] <= BarsRequired || CurrentBars[11] <= BarsRequired 
				|| CurrentBars[12] <= BarsRequired || CurrentBars[13] <= BarsRequired || CurrentBars[14] <= BarsRequired || CurrentBars[15] <= BarsRequired
				|| CurrentBars[16] <= BarsRequired || CurrentBars[17] <= BarsRequired || CurrentBars[18] <= BarsRequired || CurrentBars[19] <= BarsRequired
				|| CurrentBars[20] <= BarsRequired || CurrentBars[21] <= BarsRequired || CurrentBars[22] <= BarsRequired || CurrentBars[23] <= BarsRequired
				|| CurrentBars[24] <= BarsRequired || CurrentBars[25] <= BarsRequired || CurrentBars[26] <= BarsRequired || CurrentBars[27] <= BarsRequired
				|| CurrentBars[28] <= BarsRequired || CurrentBars[29] <= BarsRequired || CurrentBars[30] <= BarsRequired || CurrentBars[31] <= BarsRequired
				|| CurrentBars[32] <= BarsRequired || CurrentBars[33] <= BarsRequired || CurrentBars[34] <= BarsRequired				)
        		return;			
			
			
			#region GetNextOpen
			
			if (BarsInProgress == 1)	
				open_2 = Open[-1];
			if (BarsInProgress == 2)
				open_3 = Open[-1];
			if (BarsInProgress == 3)
				open_4 = Open[-1];			
			if (BarsInProgress == 4)
				open_5 = Open[-1];
			if (BarsInProgress == 5)
				open_6 = Open[-1];
			
			if (BarsInProgress == 6)	
				open_8 = Open[-1];
			if (BarsInProgress == 7)
				open_9 = Open[-1];
			if (BarsInProgress == 8)
				open_10 = Open[-1];			
			if (BarsInProgress == 9)
				open_12 = Open[-1];
			if (BarsInProgress == 10)
				open_15 = Open[-1];
			
			if (BarsInProgress == 11)	
				open_16 = Open[-1];
			if (BarsInProgress == 12)
				open_18 = Open[-1];
			if (BarsInProgress == 13)
				open_20 = Open[-1];			
			if (BarsInProgress == 14)
				open_24 = Open[-1];
			if (BarsInProgress == 15)
				open_30 = Open[-1];
			
			if (BarsInProgress == 16)	
				open_32 = Open[-1];
			if (BarsInProgress == 17)
				open_36 = Open[-1];
			if (BarsInProgress == 18)
				open_40 = Open[-1];			
			if (BarsInProgress == 19)
				open_45 = Open[-1];
			if (BarsInProgress == 20)
				open_48 = Open[-1];
			
			if (BarsInProgress == 21)	
				open_60 = Open[-1];
			if (BarsInProgress == 22)
				open_72 = Open[-1];
			if (BarsInProgress == 23)
				open_80 = Open[-1];			
			if (BarsInProgress == 24)
				open_90 = Open[-1];
			if (BarsInProgress == 25)
				open_96 = Open[-1];	
			
			if (BarsInProgress == 26)	
				open_120 = Open[-1];
			if (BarsInProgress == 27)
				open_144 = Open[-1];
			if (BarsInProgress == 28)
				open_160 = Open[-1];			
			if (BarsInProgress == 29)
				open_180 = Open[-1];
			if (BarsInProgress == 30)
				open_240 = Open[-1];	
			
			if (BarsInProgress == 31)	
				open_288 = Open[-1];
			if (BarsInProgress == 32)
				open_360 = Open[-1];
			if (BarsInProgress == 33)
				open_480 = Open[-1];			
			if (BarsInProgress == 34)
				open_720 = Open[-1];
			if (BarsInProgress == 35)
				open_1440 = Open[-1];				
			#endregion
			
			if (BarsInProgress == 0)
			{
				#region AssignOpens
				TF_2[0] = open_2;	
				TF_3[0] = open_3;	
				TF_4[0] = open_4;	
				TF_5[0] = open_5;	
				TF_6[0] = open_6;	
				TF_8[0] = open_8;	
				TF_9[0] = open_9;	
				TF_10[0] = open_10;	
				TF_12[0] = open_12;	
				TF_15[0] = open_15;	
				
				TF_16[0] = open_16;
				TF_18[0] = open_18;
				TF_20[0] = open_20;
				TF_24[0] = open_24;
				TF_30[0] = open_30;
				TF_32[0] = open_32;
				TF_36[0] = open_36;
			//-----------------------------------------	
				TF_40[0] = open_40;
				TF_45[0] = open_45;
				TF_48[0] = open_48;
				
				TF_60[0] = open_60;
				TF_72[0] = open_72;
				TF_80[0] = open_80;
				TF_90[0] = open_90;
				TF_96[0] = open_96;
				TF_120[0] = open_120;
				TF_144[0] = open_144;
				TF_160[0] = open_160;
				TF_180[0] = open_180;
				TF_240[0] = open_240;
				
				TF_288[0] = open_288;
				TF_360[0] = open_360;
				TF_480[0] = open_480;
				TF_720[0] = open_720;
				TF_1440[0] = open_1440;				
				#endregion
				
//				Print(  Time[0].ToShortDateString() + ","+ Time[0].ToLongTimeString() +"," + Time[0].ToString()
//				+","+Open[0] +","+High[0]+","+Low[0]+","+Close[0]
//				+","+ TF_2[0]+","+ TF_3[0]+","+ TF_4[0]+","+ TF_5[0]+","+ TF_6[0]
//				+","+ TF_8[0]+","+ TF_9[0]+","+ TF_10[0]+","+ TF_12[0]+","+ TF_15[0]
//				+","+ TF_16[0]+","+ TF_18[0]+","+ TF_20[0]+","+ TF_24[0]+","+ TF_30[0]
//				+","+ TF_32[0]+","+ TF_36[0]+","+ TF_40[0]+","+ TF_45[0]+","+ TF_48[0]
//				+","+ TF_60[0]+","+ TF_72[0]+","+ TF_80[0]+","+ TF_90[0]+","+ TF_96[0]
//				+","+ TF_120[0]+","+ TF_144[0]+","+ TF_160[0]+","+ TF_180[0]+","+ TF_240[0]
//				+","+ TF_288[0]+","+ TF_360[0]+","+ TF_480[0]+","+ TF_720[0]+","+ TF_1440[0]  );
				
				
				#region StreamWriterStuff
				try
				{
					// If file at 'path' doesn't exist it will create the file. If it does exist it will append the file.
					if (printHeader)	{
//						sw = File.AppendText(path);
//						printHeader = false;
						
//					sw.WriteLine("Date" + ", "+ "Time"+", " + "dTime"+", " + "O"+", " + "H"+", " + "L"+", " + "C"
//						+"," + "m2"+"," + "m3"+"," + "m4"+"," + "m5"+"," + "m6"+", " + "m8"+"," + "m9"+", " + "m10"+"," + "m12"+"," + "m15"
//						+"," + "m16"+"," + "m18"+"," + "m20"+"," + "m24"+"," + "m30"+", " + "m32"+"," + "m36"+", " + "m40"+"," + "m45"+"," + "m48"
//						+"," + "m60"+"," + "m72"+"," + "m80"+"," + "m90"+"," + "m96"+", " + "m120"+"," + "m144"+", " + "m160"+"," + "m180"+"," + "m240"
//						+"," + "m288"+"," + "m360"+"," + "m480"+"," + "m720"+"," + "m1440");						
					}
					
					// This is the output of all lines.	The output format is as follows: Date Open High Low Close
//					sw.WriteLine(  Time[0].ToShortDateString() + ","+ Time[0].ToLongTimeString() +"," + Time[0].ToString()
//									+","+Open[0] +","+High[0]+","+Low[0]+","+Close[0]
//									+","+ TF_2[0]+","+ TF_3[0]+","+ TF_4[0]+","+ TF_5[0]+","+ TF_6[0]
//									+","+ TF_8[0]+","+ TF_9[0]+","+ TF_10[0]+","+ TF_12[0]+","+ TF_15[0]
//									+","+ TF_16[0]+","+ TF_18[0]+","+ TF_20[0]+","+ TF_24[0]+","+ TF_30[0]
//									+","+ TF_32[0]+","+ TF_36[0]+","+ TF_40[0]+","+ TF_45[0]+","+ TF_48[0]
//									+","+ TF_60[0]+","+ TF_72[0]+","+ TF_80[0]+","+ TF_90[0]+","+ TF_96[0]
//									+","+ TF_120[0]+","+ TF_144[0]+","+ TF_160[0]+","+ TF_180[0]+","+ TF_240[0]
//									+","+ TF_288[0]+","+ TF_360[0]+","+ TF_480[0]+","+ TF_720[0]+","+ TF_1440[0]  );
				}
				
				catch (Exception e)
				{
					// Outputs the error to the log
					Log("You cannot write and read from the same file at the same time. Please remove SampleStreamReader.", NinjaTrader.Cbi.LogLevel.Error);
					throw;
				}
				
				#endregion				

			}	
	
        }

		protected override void OnTermination() 		//Added for StreamWriter
		{
			// Disposes resources used by the StreamWriter
			if (sw != null)
			{
				sw.Dispose();
				sw = null;
			}
		}		
		
		
        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_2
        {
            get { return Values[0]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_3
        {
            get { return Values[1]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_4
        {
            get { return Values[2]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_5
        {
            get { return Values[3]; }
        }	
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_6
        {
            get { return Values[4]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_8
        {
            get { return Values[5]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_9
        {
            get { return Values[6]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_10
        {
            get { return Values[7]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_12
        {
            get { return Values[8]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_15
        {
            get { return Values[9]; }
        }	
		
		
		
		
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_16
        {
            get { return Values[10]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_18
        {
            get { return Values[11]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_20
        {
            get { return Values[12]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_24
        {
            get { return Values[13]; }
        }	
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_30
        {
            get { return Values[14]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_32
        {
            get { return Values[15]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_36
        {
            get { return Values[16]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_40
        {
            get { return Values[17]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_45
        {
            get { return Values[18]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_48
        {
            get { return Values[19]; }
        }
		
		

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_60
        {
            get { return Values[20]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_72
        {
            get { return Values[21]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_80
        {
            get { return Values[22]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_90
        {
            get { return Values[23]; }
        }	
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_96
        {
            get { return Values[24]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_120
        {
            get { return Values[25]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_144
        {
            get { return Values[26]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_160
        {
            get { return Values[27]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_180
        {
            get { return Values[28]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_240
        {
            get { return Values[29]; }
        }	
		
		
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_288
        {
            get { return Values[30]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_360
        {
            get { return Values[31]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_480
        {
            get { return Values[32]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_720
        {
            get { return Values[33]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TF_1440
        {
            get { return Values[34]; }
        }		
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private HG5_CP_Opens[] cacheHG5_CP_Opens = null;

        private static HG5_CP_Opens checkHG5_CP_Opens = new HG5_CP_Opens();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public HG5_CP_Opens HG5_CP_Opens()
        {
            return HG5_CP_Opens(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public HG5_CP_Opens HG5_CP_Opens(Data.IDataSeries input)
        {
            if (cacheHG5_CP_Opens != null)
                for (int idx = 0; idx < cacheHG5_CP_Opens.Length; idx++)
                    if (cacheHG5_CP_Opens[idx].EqualsInput(input))
                        return cacheHG5_CP_Opens[idx];

            lock (checkHG5_CP_Opens)
            {
                if (cacheHG5_CP_Opens != null)
                    for (int idx = 0; idx < cacheHG5_CP_Opens.Length; idx++)
                        if (cacheHG5_CP_Opens[idx].EqualsInput(input))
                            return cacheHG5_CP_Opens[idx];

                HG5_CP_Opens indicator = new HG5_CP_Opens();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                HG5_CP_Opens[] tmp = new HG5_CP_Opens[cacheHG5_CP_Opens == null ? 1 : cacheHG5_CP_Opens.Length + 1];
                if (cacheHG5_CP_Opens != null)
                    cacheHG5_CP_Opens.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheHG5_CP_Opens = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.HG5_CP_Opens HG5_CP_Opens()
        {
            return _indicator.HG5_CP_Opens(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.HG5_CP_Opens HG5_CP_Opens(Data.IDataSeries input)
        {
            return _indicator.HG5_CP_Opens(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.HG5_CP_Opens HG5_CP_Opens()
        {
            return _indicator.HG5_CP_Opens(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.HG5_CP_Opens HG5_CP_Opens(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.HG5_CP_Opens(input);
        }
    }
}
#endregion
